# =====================================================================
# AWK functions for CSA.
#
# Copyright (c) 2001,2006 Carlo Strozzi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 dated June, 1991.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License 
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# =====================================================================
# $Id: _rdftype.awk 43 2007-09-24 08:30:21Z carlo $
# =====================================================================
# string _rdftype(string s)
#
# Trivial RDF datatype autodetect function. Note that it is not
# absolutely bullet-proof.
# =====================================================================

function _rdftype(s,		double_re,int_re,time_re,type) {

  # types auto-detection not bullet-proof, but should work in most cases.
  double_re = "^[-+]?[0-9]+\\.[0-9]+$"
  int_re = "^[-+]?[0-9]+([-+][1-9][0-9]?)?$" # accept 123456+10 notation
  time_re = "^([0-9]+-?)+[T ][0-2][0-9]:[0-5][0-9]:[0-5][0-9][-+]?"

  if (s != "") {

     if (s ~ double_re) type = "double"
     else if (s ~ int_re) type = "int"
     else if (s ~ time_re) type = "dateTime"
     else type = "string"
  }
  else type = "string"

  return "xsd:" type
}

