# =====================================================================
# AWK functions for CSA.
# 
# Copyright (c) 2001,2009 Carlo Strozzi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 dated June, 1991.
# 
# This program is distributed in the hope that it will be useful,  
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# =====================================================================

BEGIN {

  _RESULT = _INCLUDEPATH = _NULL

  _RDFPRINT = 1

  _MSG[0] = 0				# message array.

  # Various flags and misc. names.
  _O_TRUNC = _O_REQUEST = 0
  _O_APPEND = _O_RESPONSE = _O_NOENC = 1
  _O_PATHINFO = _O_CURR = _O_UPNAME = 1
  _O_ATTACH = 2

  _REQ_CHARSET = tolower(ENVIRON["CSA_REQ_CHARSET"])

  _XMLTOP = "<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"no\"?>"

  # Get misc. local settings.
  _CSAINST = ENVIRON["CSA_INSTALL"]
  _STDOUT = ENVIRON["CSA_STDOUT"]
  _STDERR = ENVIRON["CSA_STDERR"]

  # Populate the list of uploaded files, if any. This list is created
  # by csaCgi.awk if any files are uploaded by the client, and it
  # must be passed to subsequent AWK scripts through the underlying
  # rc(1) program.

  split(ENVIRON["CSA_RPC_UPLOAD"],_UPLOAD,"\001")
  for (i in _UPLOAD) {
      _UPLOAD[_UPLOAD[i]] = _UPLOAD[i]
      _UPLOAD[i] = _NULL
  }

  # Set default values if necessary.
  if (_CSAINST !~ /^\//) _CSAINST = "/usr/local/csa"
  if (_STDOUT !~ /^\//) _STDOUT = "/dev/stdout"
  if (_STDERR !~ /^\//) _STDERR = "/dev/stderr"

  # Set the array of supported national languages.
  _LANG["en"] = "en"
  _LANG["en_UK"] = "en_UK"
  _LANG["en_US"] = "en_US"
  _LANG["es"] = "es"
  _LANG["it"] = "it"

  # Set local time values if available.
  _TIME["Y"] = _rcget("CSA_TIME_LOCAL",1)
  _TIME["m"] = _rcget("CSA_TIME_LOCAL",2)
  _TIME["d"] = _rcget("CSA_TIME_LOCAL",3)
  _TIME["H"] = _rcget("CSA_TIME_LOCAL",4)
  _TIME["M"] = _rcget("CSA_TIME_LOCAL",5)
  _TIME["S"] = _rcget("CSA_TIME_LOCAL",6)
  _TIME["Z"] = _rcget("CSA_TIME_LOCAL",7)
  _TIME["a"] = _rcget("CSA_TIME_LOCAL",8)
  _TIME["b"] = _rcget("CSA_TIME_LOCAL",9)
  _TIME["s"] = _rcget("CSA_TIME_LOCAL",10)
  _TIME["z"] = _rcget("CSA_TIME_LOCAL",11)
  _TIME[":z"] = _rcget("CSA_TIME_LOCAL",12)

  # Set UTC time values if available.
  _UTIME["Y"] = _rcget("CSA_TIME_UTC",1)
  _UTIME["m"] = _rcget("CSA_TIME_UTC",2)
  _UTIME["d"] = _rcget("CSA_TIME_UTC",3)
  _UTIME["H"] = _rcget("CSA_TIME_UTC",4)
  _UTIME["M"] = _rcget("CSA_TIME_UTC",5)
  _UTIME["S"] = _rcget("CSA_TIME_UTC",6)
  _UTIME["Z"] = _rcget("CSA_TIME_UTC",7)
  _UTIME["a"] = _rcget("CSA_TIME_UTC",8)
  _UTIME["b"] = _rcget("CSA_TIME_UTC",9)
  _UTIME["s"] = _rcget("CSA_TIME_UTC",10)
  _UTIME["z"] = _rcget("CSA_TIME_UTC",11)
  _UTIME[":z"] = _rcget("CSA_TIME_UTC",12)
}

