# =====================================================================
# AWK functions for CSA.
#
# Copyright (c) 2001,2009 Carlo Strozzi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 dated June, 1991.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License 
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# =====================================================================
# string _localdate(string iso_date, [boolean res])
#
# Takes a date string, in the ISO format "YYYY-mm-dd[T][HH:MM:SS][tz]"
# and returns the equivalent dd/mm/yyyy or mm/dd/yyyy string, based on
# CSA_LANG. If the optional resolution argument is "1", then HH:MM:SS
# are also returned, whether they were provided by the caller or not.
# =====================================================================

function _localdate(date,res,		local_date,token,i) {

  date = substr(date,1,19)			# drop any TZ value.

  local_date = _strip(date)

  if (local_date == _NULL) return _NULL

  if (split(date,token,/[ T]/) < 2 && res) token[2] = "00:00:00"

  # Add seconds if only HH:MM are present.
  if (token[2] ~ /^[0-2][0-9]:[0-5][0-9]$/) token[2] = token[2] ":00"

  date = token[1] " " token[2]
  if ((i=split(date, token, /[- :]/)) < 3 || i > 6) return _NULL

  if (ENVIRON["CSA_LANG"] != "en_US") {			# Non-US
     local_date = token[3] "/" token[2] "/" token[1]
  }  else {						# US English
     local_date = token[2] "/" token[3] "/" token[1]
  }

  if (res)
     local_date = local_date " " token[4] ":" token[5] ":" token[6]

  return local_date
}

