# =====================================================================
# AWK functions for CSA.
#
# Copyright (c) 2004,2006 Carlo Strozzi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 dated June, 1991.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License 
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# =====================================================================
# void _response(string name, string value,\
#				int argnum, int argpos, boolean noenc)
#
# Prepare encoded versions of the specified name/value pair, for use in
# response templates. If 'noenc' is non-zero, then 'value' is not
# encoded and is loaded verbatim into ENVIRON[]. This is mainly meant
# to allow for the inclusion of literal [X]HTML fragments.
# The 'argnum' and 'argpos' parameters are used to produce the CSA-RPC
# response, if needed. See also '_tbltordf()'.
# =====================================================================

function _response(name,value,argnum,argpos,noenc,	i,a,nf) {

  # The 'noenc' option was left in place for backward compatibility
  # but it is obsolete.

  if (name != _NULL) {
     gsub(/\./,"__2e",name)		# Allow rc(1) encoded dots.

     # We can overwrite any environment entry here, but the
     # template processor will drop what is not allowed on output.

     ENVIRON[name] = value
  }

  if (argnum && argpos) {
     if (argnum > _OUT[0]) _OUT[0] = argnum
     nf = split(_OUT[argnum],a,"\t")
     if (argpos > nf) nf = argpos
     a[argpos] = value
     gsub(/\t/,"\\t",a[argpos])
     gsub(/\n/,"\\n",a[argpos])
     _OUT[argnum] = a[1]
     for (i=2; i<=nf; i++) _OUT[argnum] = _OUT[argnum] "\t" a[i]
  }
}

